#!/usr/bin/perl

while(<>) {

    chomp($_);

    $_ =~ s/\r//g;

    $d = 20; # window size
	
    $line[$i % $d] = $_;
    # ^ Create an array $t[][] that will be filled with 20 adjacent words (20 lines in the input). The line[] array has 20 lines, but they may not be correctly
    # ordered. If we're at word 50 (i=50): that word replaces word 30 at position 10 in the array; the array contains words 40-50 (in line[] slots 0 through 10)
    # followed by words 31-39 (in line[] slots 11 through 19). 
    # Now we rotate the words so that they are correctly ordered, and read the elements of the line (textblock#, word, lemma, pos) into $t[line][element].
    # If i=50, the 0th position of the $t[][] will be the word in line[(0 + (50 % 20) + 1) % 20] = line[11] = word 31; the 19th position will be line[10] = word 50.
    
    for($x=0; $x<$d; $x++) {
	@wa = split(/\t/, $line[ ($x + ($i % $d) + 1) % $d ]);      
	for($w=0; $w<@wa; $w++) {
	    $t[$x][$w] = $wa[$w];
	}
    }
    if($i >= $d) {

	if($t[9][3] =~ /^nn1/ && $t[9][1] !~ /^[A-Z]/ && $t[10][3] =~ /^np/ && $t[11][3] =~ /^np/) {

	    printf("%d\t", $i-10);
	    for($w=0; $w<$d; $w++) {
		if($w == 9) {
		    printf("[ ");
		}
		if($w == 12) {
		    printf("] ");
		}
		printf("%s ", $t[$w][1]);
	    }
	    printf("\n");
	}
    }
    
    # if($i % 1000000 == 0) {
	# printf("%d: %s\n", $i, $t[9][1]);
    # }

    $i++;
}
