#!/usr/bin/perl

@skipword = ("other", "like", "left", "past", "military", "opposite", "potential", "outside", "original");

while(<>) {

    chomp($_);

    $_ =~ s/\r//g;

    $d = 20; # window size
	
    $line[$i % $d] = $_;                                                 # Create an array $t[][] that will be filled with 20 adjacent words (20 lines in the input).
    for($x=0; $x<$d; $x++) {
	@wa = split(/\t/, $line[ ($x + ($i % $d) + 1) % $d ]);
	for($w=0; $w<@wa; $w++) {
	    $t[$x][$w] = $wa[$w];
	}
    }
    if($i >= $d) {

	# look for "the" adj, not superlative/comparative, not followed by a noun (n), adjective (j), number (m), (quotes + n/j/m), "@/one/ones", or ((cc or ",") + adj),
	# and where the adj is not on the skipword list

	$skip = 0;
	for($s=0; $s<@skipword; $s++) {                # Skip words on skipword list (the same list as in coca2/detadj-process2.pl, except without "above")
	    if($t[$d-11][1] eq $skipword[$s] || $t[$d-11][1] =~ /^[A-Z]/) {
		$skip = 1;
	    }
	}
	if($skip == 1) {
	    $i++;
	    next;
	}

        if($t[$d-12][1] =~ /^[Tt]he$/ && $t[$d-11][3] =~ /^jj/                   # find the + adj, 
	   && $t[$d-11][3] !~ /^jj[tr]/ && $t[$d-10][3] !~ /^(n|j|m)/            # skip superlatives and comparatives, and cases where the next word is n/j/m
	   && !( $t[$d-10][1] eq "\"" && $t[$d-9][3] =~ /^(n|j|m)/ )             # skip cases followed by quotes and n/j/m
	   && $t[$d-10][1] !~ /^(@|one|ones)$/
	   && !( ($t[$d-10][1] eq "," || $t[$d-10][3] =~ /^cc/) && $t[$d-9][3] =~ /^jj/)   # skip cases followed by (cc or ",") + adj
	    ) {
	    
	    printf("%d\t", $i-10);
	    for($w=0; $w<$d; $w++) {
		if($w == $d-12) {
		    printf("[ ");
		}
		printf("%s ", $t[$w][1]);
		if($w == $d-11) {
		    printf("] ");
		}
	    }
	    printf("\n");
	}
    }
    
    # if($i % 1000000 == 0) {
	# printf("%d: %s\n", $i, $t[9][1]);
    # }

    $i++;
}
